package com.example.iasaelectronica.wifi2ctrl;

import android.content.SharedPreferences;
import android.media.MediaPlayer;
import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.Spinner;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Toast;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.RadioGroup.OnCheckedChangeListener;
import android.widget.LinearLayout;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;
import java.net.UnknownHostException;
import java.text.ParseException;

public class ConfigActivity extends AppCompatActivity {
    private String[] Canales={"1","2","3","4","5","6","7","8","9","10","11","12","13","14"};
    private String[] Seguridad={"Abierto","WEP","WPA PSK","WPA2 PSK","WPA WPA2 PSK"};
    private String dip1,port1,ssidmc,passmc,ipmc,gwmc,msmc,ssidap,passap,canal,seguridad;
    private String dhcpsn="N";
    private RadioGroup radioGroup;
    private RadioButton ModoCliente, ModoSoftAP;
    private CheckBox Dhcp;
    private EditText PuertoServer,SSID, Password,IpModoCliente,GwModoCliente,MsModoCliente,SSIDAP,PasswordAP;
    private LinearLayout LayoutCliente,LayoutSoftAP;
    private Button BtnConfig;
    MediaPlayer mp;
    MediaPlayer mp2;
    MediaPlayer ok;
    MediaPlayer error;
    String poscanal="0";
    String posseguridad="0";
    int modo=0;//0=cliente, 1=softAP



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_config);



        final Spinner spincanal = (Spinner) findViewById(R.id.spinnercanal);
        Spinner spinseguridad = (Spinner) findViewById(R.id.spinnerseguridad);
        LayoutCliente = (LinearLayout) findViewById(R.id.setcliente);
        LayoutSoftAP = (LinearLayout) findViewById(R.id.setsoftap);
        Dhcp =(CheckBox)findViewById(R.id.dhcp);
        PuertoServer = (EditText) findViewById(R.id.puertoserver);
        SSID = (EditText) findViewById(R.id.ssid);
        Password = (EditText) findViewById(R.id.password);
        SSIDAP = (EditText) findViewById(R.id.ssidap);
        PasswordAP = (EditText) findViewById(R.id.passwordap);
        IpModoCliente = (EditText) findViewById(R.id.ipmodocliente);
        GwModoCliente = (EditText) findViewById(R.id.gwmodocliente);
        MsModoCliente = (EditText) findViewById(R.id.msmodocliente);
        BtnConfig = (Button) findViewById(R.id.btnconfig);
        mp= MediaPlayer.create(this,R.raw.click4);
        mp2= MediaPlayer.create(this,R.raw.alarma2);
        ok= MediaPlayer.create(this,R.raw.correct1);
        error= MediaPlayer.create(this,R.raw.error1);

        cargarpreferencias();//lee configuracion

        ArrayAdapter arraycanal = new ArrayAdapter(this, android.R.layout.simple_spinner_item, Canales);
        ArrayAdapter arrayseguridad = new ArrayAdapter(this, android.R.layout.simple_spinner_item, Seguridad);

        arraycanal.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        arrayseguridad.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);

        spincanal.setAdapter(arraycanal);
        spinseguridad.setAdapter(arrayseguridad);


        int can =convertStringToInt(poscanal);
        int seg =convertStringToInt(posseguridad);
        spincanal.setSelection(can);
        spinseguridad.setSelection(seg);

        radioGroup = (RadioGroup) findViewById(R.id.RadioGroupConfig);
        LayoutCliente.setVisibility(View.VISIBLE);//mustra modo cliente
        LayoutSoftAP.setVisibility(View.GONE);//oculta moso softAP
        radioGroup.setOnCheckedChangeListener(new OnCheckedChangeListener() {

            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
            // find which radio button is selected
            if (checkedId == R.id.modocliente) {
                LayoutCliente.setVisibility(View.VISIBLE);
                LayoutSoftAP.setVisibility(View.GONE);
                modo=0;
                Toast.makeText(getApplicationContext(), "Modo CLIENTE", Toast.LENGTH_SHORT).show();
            } else if (checkedId == R.id.modosoftap) {
                LayoutCliente.setVisibility(View.GONE);
                LayoutSoftAP.setVisibility(View.VISIBLE);
                modo=1;
                Toast.makeText(getApplicationContext(), "Modo SoftAP", Toast.LENGTH_SHORT).show();
            }
            }
        });
        ModoCliente = (RadioButton) findViewById(R.id.modocliente);
        ModoSoftAP = (RadioButton) findViewById(R.id.modosoftap);

        //////////boton configurar//////////////////
        BtnConfig.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View arg0) {
                guardarpreferencias();
                mp.start();//sonido boton

                if(MainActivity.SetConfiguracionAP(getApplicationContext(),port1,modo,dhcpsn,ipmc,gwmc,msmc,ssidmc,passmc,ssidap,
                        passap,canal,posseguridad))
                {
                    Toast.makeText(getApplicationContext(), "CONFIGURACION GUARDADA :)", Toast.LENGTH_SHORT).show();
                    ok.start();
                }else
                {
                    Toast.makeText(getApplicationContext(), "ERROR EN CONFIGURACION :(", Toast.LENGTH_SHORT).show();
                    error.start();
                }

            }
        });
///////////////////////////////////////////
        Dhcp.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(Dhcp.isChecked()){
                    dhcpsn="S";
                }else{
                    dhcpsn="N";
                }
            }
        });

        spincanal.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            public void onItemSelected(AdapterView<?> parent, View view, int pos, long id) {
                Object item = parent.getItemAtPosition(pos);
                canal = parent.getSelectedItem().toString();
                poscanal = String.valueOf(pos);
                Toast.makeText(getApplicationContext(), "CANAL: "+canal, Toast.LENGTH_SHORT).show();
            }
            public void onNothingSelected(AdapterView<?> parent) {
            }
        });

        spinseguridad.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            public void onItemSelected(AdapterView<?> parent, View view, int pos, long id) {
                Object item = parent.getItemAtPosition(pos);
                seguridad = parent.getSelectedItem().toString();
                posseguridad = String.valueOf(pos);
                Toast.makeText(getApplicationContext(), "SEGURIDAD: "+seguridad, Toast.LENGTH_SHORT).show();
            }
            public void onNothingSelected(AdapterView<?> parent) {
            }
        });

    }

    public void guardarpreferencias() {
        SharedPreferences pref = getApplicationContext().getSharedPreferences("NetPref", MODE_PRIVATE);
        dip1=IpModoCliente.getText().toString();
        port1=PuertoServer.getText().toString();
        ssidmc=SSID.getText().toString();
        passmc=Password.getText().toString();
        ipmc=IpModoCliente.getText().toString();
        gwmc=GwModoCliente.getText().toString();
        msmc=MsModoCliente.getText().toString();
        dhcpsn=Dhcp.getText().toString();
        ssidap=SSIDAP.getText().toString();
        passap=PasswordAP.getText().toString();

        SharedPreferences.Editor editor=pref.edit();
        editor.putString("dir1",dip1);
        editor.putString( "port1",port1);
        editor.putString( "ssidmc",ssidmc);
        editor.putString( "passmc",passmc);
        editor.putString( "ipmc",ipmc);
        editor.putString( "gwmc",gwmc);
        editor.putString( "msmc",msmc);
        editor.putString( "dhcpsn",dhcpsn);
        editor.putString( "canal",poscanal);
        editor.putString( "seguridad",posseguridad);
        editor.putString( "ssidap",ssidap);
        editor.putString( "passap",passap);
        editor.commit();

    }

    public void cargarpreferencias() {
        SharedPreferences pref = getApplicationContext().getSharedPreferences("NetPref", MODE_PRIVATE);
        dip1=pref.getString("dir1","0.0.0.0");
        port1=pref.getString("port1","0000");
        ssidmc=pref.getString("ssidmc","");
        passmc=pref.getString("passmc","......");
        ipmc=pref.getString("ipmc","0.0.0.0");
        gwmc=pref.getString("gwmc","0.0.0.0");
        msmc=pref.getString("msmc","0.0.0.0");
        dhcpsn=pref.getString("dhcpsn","N");
        poscanal=pref.getString("canal","10");
        posseguridad=pref.getString("seguridad","0");
        ssidap=pref.getString("ssidap","");
        passap=pref.getString("passap","......");

        IpModoCliente.setText(dip1);
        PuertoServer.setText(port1);
        SSID.setText(ssidmc);
        Password.setText(passmc);
        IpModoCliente.setText(ipmc);
        GwModoCliente.setText(gwmc);
        MsModoCliente.setText(msmc);
        SSIDAP.setText(ssidap);
        PasswordAP.setText(passap);
        if(dhcpsn.intern() =="S")
        {
            Dhcp.setChecked(true);
        }else{
            Dhcp.setChecked(false);
        }

    }

    public int convertStringToInt(String numero) {
        int parse_numero = 0;
        try {
            parse_numero = Integer.parseInt(numero);

        } catch (NumberFormatException e) {

        }
        return parse_numero;
    }


    /* SetServerPort
     *  Argumentos:
     *      - Dirección IP (String): 255.255.255.255 (Valores de 0-255).
     *      - Port (String): 0-65000.
     *      - Comando: el comando a enviar.
     *
     *  Return:
     *      -   1: Ok
     *      -  -1: Error al establecer la comunicación con el equipo.
     *      -  -2: Error de envío de datos.
     *      -  -3: Error de recepción de datos.
     *      -  -4: Error por recepción de datos incorrectos.
     *      -  -5: Error dirección Ip incorrecta.
     *      -  -6: Error puerto incorrecto.
     */
    /*
    public int SetServerPort(String ip, String port, String new_port)
    {

       // if (ValidarIP(ip) < 0)
       //    return -5;

       // if (ValidarPuerto(port) < 0)
       //     return -6;

       // if (ValidarPuerto(new_port) < 0)
       //     return -7;

        int puerto;

        try
        {
            puerto=convertStringToInt(new_port);
        }
        catch(Exception e)
        {return -7;}

        String mensaje_str = "SET_SERVER_PORT=";
        //---------- Permite pasar de String a un array de bytes ---------------//
        char[] array_aux = mensaje_str.toCharArray();
        byte[] mensaje = new byte[array_aux.length+4];

        for (int cont = 0; cont < array_aux.length; cont++)
            mensaje[cont] = (byte)(array_aux[cont]);
        //---------- Permite pasar de String a un array de bytes ---------------//

        mensaje[array_aux.length]=(byte)((puerto >> 24) & 0xff);
        mensaje[array_aux.length+1]=(byte)((puerto >> 16) & 0xff);
        mensaje[array_aux.length+2]=(byte)((puerto >> 8) & 0xff);
        mensaje[array_aux.length+3]=(byte)(puerto & 0xff);

        byte[] datos_obtenidos = new byte[1];
        message = "GET_PORTS\r\n";
        send_text();
        espera(1000);
        return EnviarDatosEthernetAck(ip, port, mensaje, datos_obtenidos);
    }
*/

}
