package com.example.iasaelectronica.wifi2ctrl;

import android.annotation.TargetApi;
import android.graphics.Color;
import android.media.MediaPlayer;
import android.os.Build;
import android.os.Handler;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.TimePicker;
import android.widget.Toast;

import java.text.Format;
import java.text.SimpleDateFormat;
import java.time.Instant;
import java.util.Calendar;
import java.util.Date;
import java.util.Timer;
import java.util.TimerTask;

public class ConfigTimeActivity extends AppCompatActivity {
    private EditText Fecha, Horas, Minutos, Segundos;
    private Integer ano,mes,dia;
    Button LeerRTC,GrabarRTC;
    MediaPlayer mp;
    MediaPlayer mp2;
    MediaPlayer ok;
    MediaPlayer error;
    TimePicker timePicker;
    private Timer mTimer1;
    private TimerTask mTt1;
    private Handler mTimerHandler = new Handler();
   ////////////////timer del reloj/////////////////
    private void startTimer(){
        mTimer1 = new Timer();
        mTt1 = new TimerTask() {
            public void run() {
                mTimerHandler.post(new Runnable() {
                    public void run(){
                      setFechaActual();
                      setHoraActual();
                    }
                });
            }
        };
        mTimer1.schedule(mTt1, 1, 1000);
    }

 ///////////////////////////////////////////////////



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_config_time);

        GrabarRTC = (Button) findViewById(R.id.grabarrtc);
        LeerRTC = (Button) findViewById(R.id.leerrtc);

        Fecha = (EditText) findViewById(R.id.fecha);
        Horas = (EditText) findViewById(R.id.horas);
        Minutos = (EditText) findViewById(R.id.minutos);
        Segundos = (EditText) findViewById(R.id.segundos);

        mp = MediaPlayer.create(this, R.raw.click4);
        mp2 = MediaPlayer.create(this, R.raw.alarma2);
        ok = MediaPlayer.create(this, R.raw.correct1);
        error = MediaPlayer.create(this, R.raw.error1);

        timePicker= (TimePicker)findViewById(R.id.reloj);
        setFechaActual();
        setHoraActual();

        GrabarRTC.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View arg0) {
                mp.start();//sonido boton
                setFechaActual();


               long e = System.currentTimeMillis()/1000 -3*60*60;


                Integer epoch = (int) e;
                boolean resul=MainActivity.SetRTC(getApplicationContext(),epoch);
                if(resul==true)
                {
                    //Toast.makeText(getApplicationContext(), "EPOCH)"+Integer.toString(epoch), Toast.LENGTH_SHORT).show();
                }else
                {
                    Toast.makeText(getApplicationContext(), "ERROR AL GRABAR RTC :(", Toast.LENGTH_SHORT).show();
                }
            }
        });

        LeerRTC.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View arg0) {
                mp.start();//sonido boton
                setHoraActual();
                int epoch=MainActivity.GetRTC(getApplicationContext());
                if(epoch>0)
                {
                    //Toast.makeText(getApplicationContext(), "EPOCH)"+Integer.toString(epoch), Toast.LENGTH_SHORT).show();
                }else
                {
                    Toast.makeText(getApplicationContext(), "ERROR AL LEER RTC :(", Toast.LENGTH_SHORT).show();
                }
            }
        });
        startTimer();// inicia el timer para actualizacion del reloj
    }

    public void setFechaActual()
    {
        final Calendar c = Calendar.getInstance();
        ano = c.get(Calendar.YEAR);
        mes = c.get(Calendar.MONTH);
        dia = c.get(Calendar.DAY_OF_MONTH);
        Format formatter = new SimpleDateFormat("dd/MM/yyyy");
        String s = formatter.format(c.getTime());
        Fecha.setText(s);
     //   Log.e("TCP", "BOTON DE RELE 1 : " + new String(message));
    }

    public void setHoraActual()
    {
        final Calendar c = Calendar.getInstance();
        int getHour = timePicker.getCurrentHour();
        int getMinute = timePicker.getCurrentMinute();
        c.set(Calendar.HOUR_OF_DAY, timePicker.getCurrentHour());
        c.set(Calendar.MINUTE, timePicker.getCurrentMinute());
        Date fecha = new java.util.Date(); //manejador de fechas
        int f=fecha.getHours();
        int m=fecha.getMinutes();
        int s=fecha.getSeconds();
        Horas.setText(Integer.toString(f));
        Minutos.setText(Integer.toString(m));
        Segundos.setText(Integer.toString(s));

    }

}


